package com.flyer.foster.util;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.Map;

/**
 * 获取 WX 单例 AccessToken
 */
@Data
public class WxAccessToken {

    private static Map<String , WxAccessToken> instance = new HashMap<>();


    public static WxAccessToken getInstance(WeChatApiUtil weChatApiUtil, String appId, String secret){
        WxAccessToken wxAccessToken = instance.get(appId);
        if(wxAccessToken != null && !wxAccessToken.isExpires(wxAccessToken)){
            return wxAccessToken;
        }
        JSONObject obj= weChatApiUtil.getAccessToken1(appId, secret);
        wxAccessToken = new WxAccessToken();
        wxAccessToken.expires_in = obj.getInteger("expires_in");
        wxAccessToken.expires = LocalDateTime.now().plusSeconds(wxAccessToken.expires_in - 100);
        wxAccessToken.access_token = obj.getString("access_token");
        instance.put(appId, wxAccessToken);
        return wxAccessToken;
    }

    /**
     * 判断当期token是否过期
     * @return
     */
    private boolean isExpires(WxAccessToken wxAccessToken){
        return LocalDateTime.now().isAfter(wxAccessToken.expires);
    }


    private WxAccessToken(){}

    private LocalDateTime expires;
    private String access_token;
    private Integer expires_in;



}
